#include <common.h>
#include <board/sh_util.h>
#include <board/bootbank.h>

int get_boot_bank( void )
{
	int *addr = (int *)FWBANK_BOOTFLAG_OFFSET;
	int bank_num = (*addr)&0x00000003;

	printf("boot bank = %08x\n", *addr);
	/* check magic number */
	if( (((*addr) & 0xFFFF0000)!= SWUPFLAG_MAGIC) ||
		(bank_num != 0 && bank_num != 1 && bank_num != 2 && bank_num != 3) )
	{
		/* invalid */
		printf("*********************************\n");
		printf(" Warning! Bad Magic num data\n");
		printf(" Magic num  area on DDR is broken!\n");
		printf("*********************************\n");
		bank_num = 0;
	}

	return bank_num;
}
