/*
 * Copyright (C) 2010 Panasonic Corporation
 * All Rights Reserved.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <common.h>
#include <asm/mach-types.h>
#include <config.h>
#include <netdev.h>

DECLARE_GLOBAL_DATA_PTR;

#if  defined(CONFIG_SC_UART) || defined(CONFIG_SMC911X)
#define support_card_base	gd->arch.support_card_base
#endif

#ifdef CONFIG_UNIPHIER_AVEV4
int mn_avev3_initialize(int dev_num, int base_addr);
#endif

#ifdef CONFIG_BOARD_EARLY_INIT_F
int board_early_init_f(void)
{
#if defined(CONFIG_SC_UART) || defined(CONFIG_SMC911X)
#define SBBASE0		0x58C00100
	if (((*(volatile u32 *)(SBBASE0)) & 0x1) == 0) {
		support_card_base = SUPPORT_CARD_BASE_SRAMBOOT;	/* sram boot mode */
	} else {
		support_card_base = SUPPORT_CARD_BASE_NANDBOOT;	/* nand boot mode */
	}

	*(volatile u16 *)(support_card_base + 0x01FD0034) = 0x0000;
#endif

	return 0;
}
#endif /* CONFIG_BOARD_EARLY_INIT_F */

/*
 * Routine: board_init
 * Description: Early hardware init.
 */
int board_init(void)
{
	/* board id for Linux */
	gd->bd->bi_arch_number = MACH_TYPE_MN2WS0310_REF;
	/* boot param addr */
	gd->bd->bi_boot_params = (LINUX_BOOT_PARAM_ADDR);

#if 0 /* modify sharp (setting at console_init_f) */
#ifdef CONFIG_SILENT_CONSOLE
	gd->flags |= GD_FLG_SILENT;
#else
	gd->flags &= ~GD_FLG_SILENT;
#endif
#endif

	return 0;
}

#ifdef CONFIG_GENERIC_MMC
int uniphier_mmc_init(bd_t *bis);

int board_mmc_init(bd_t *bis)
{
	uniphier_mmc_init(bis);

	return 0;
}
#endif

#ifdef CONFIG_CMD_NET
int board_eth_init(bd_t *bis)
{
	int rc = 0;

#ifdef CONFIG_SMC911X
	if (smc911x_initialize(0, CONFIG_SMC911X_BASE) > 0)
		rc++;
#endif

#ifdef CONFIG_UNIPHIER_AVEV4
	if (mn_avev3_initialize(0, CONFIG_UNIPHIER_ETHERNET_BASE) > 0)
		rc++;
#endif

	return rc;
}
#endif /* CONFIG_CMD_NET */
