/*
 * Copyright (C) 2014 Panasonic Corporation
 * All Rights Reserved.
 *
 * SPDX-License-Identifier:	GPL-2.0
 */

#ifndef __UNIPHIER_MMC__H__
#define __UNIPHIER_MMC__H__

#if defined(CONFIG_MN2WS0220_ref) || defined(CONFIG_MN2WS0230_ref)
#define SYSTEM_MIO_BASEADDR	0x59810000
#define SYSTEM_MIO_CH_OFFSET	0x0200

#define SYS_MIO_CLKCTRL(x)	(SYSTEM_MIO_BASEADDR + (SYSTEM_MIO_CH_OFFSET * (x)) + 0x020)
#define SYS_MIO_MODECTRL(x)	(SYSTEM_MIO_BASEADDR + (SYSTEM_MIO_CH_OFFSET * (x)) + 0x030)
#define SYS_MIO_EMMC_HWRST(x)	(SYSTEM_MIO_BASEADDR + (SYSTEM_MIO_CH_OFFSET * (x)) + 0x080)
#define SYS_MIO_RSTCTRL(x)	(SYSTEM_MIO_BASEADDR + (SYSTEM_MIO_CH_OFFSET * (x)) + 0x110)

#define DMAC_BASEADDR	0x5a000000

#define REG_DMAC_CDMIO_STRT0		0x0000

#define REG_DMAC_CDMIO_CH_BASE		0x0100
#define REG_DMAC_CDMIO_CH_OFFSET	0x0040

#define REG_DMAC_CDMIO_CHxSTAT(x)		(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x10)
#define REG_DMAC_CDMIO_CHxIR(x)			(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x14)
#define REG_DMAC_CDMIO_CHxIE(x)			(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x18)
#define REG_DMAC_CDMIO_CHxID(x)			(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x1C)
#define REG_DMAC_CDMIO_CHxSRCAMODE(x)		(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x20)
#define REG_DMAC_CDMIO_CHxDSTAMODE(x)		(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x24)
#define REG_DMAC_CDMIO_CHxSRCSTRTADRS(x)	(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x28)
#define REG_DMAC_CDMIO_CHxDSTSTRTADRS(x)	(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x2C)
#define REG_DMAC_CDMIO_CHxSIZE(x)		(REG_DMAC_CDMIO_CH_BASE + (REG_DMAC_CDMIO_CH_OFFSET * (x)) + 0x30)

#define REG_DMAC_CDMIO_RB_BASE		0x0800
#define REG_DMAC_CDMIO_RB_OFFSET	0x0040

#define REG_DMAC_CDMIO_RBxBGNADRS(x)	(REG_DMAC_CDMIO_RB_BASE + (REG_DMAC_CDMIO_RB_OFFSET * (x)) + 0x00)
#define REG_DMAC_CDMIO_RBxENDADRS(x)	(REG_DMAC_CDMIO_RB_BASE + (REG_DMAC_CDMIO_RB_OFFSET * (x)) + 0x04)
#define REG_DMAC_CDMIO_RBxRDPTR(x)	(REG_DMAC_CDMIO_RB_BASE + (REG_DMAC_CDMIO_RB_OFFSET * (x)) + 0x20)
#define REG_DMAC_CDMIO_RBxWRPTR(x)	(REG_DMAC_CDMIO_RB_BASE + (REG_DMAC_CDMIO_RB_OFFSET * (x)) + 0x28)

#define DMAC_CDMIO_STRT0_REQ(x)		(0x00000001 << (x))
#define DMAC_CDMIO_STRT0_STOP		0x80000000

#define DMAC_CDMIO_CHAMODE_TYPE0	0x00000000
#define DMAC_CDMIO_CHAMODE_TYPE1	0x00000004
#define DMAC_CDMIO_CHAMODE_TYPE2	0x00000008
#define DMAC_CDMIO_CHAMODE_AUPDT0	0x00000000
#define DMAC_CDMIO_CHAMODE_AUPDT1	0x00000010
#define DMAC_CDMIO_CHAMODE_AUPDT2	0x00000020
#define DMAC_CDMIO_CHAMODE_SRCRSSEL	0x0000FF00
#define DMAC_CDMIO_CHAMODE_DSTRSSEL	0x0000FF00
#define DMAC_CDMIO_CHAMODE_ENDIAN0	0x00000000
#define DMAC_CDMIO_CHAMODE_ENDIAN1	0x00010000
#define DMAC_CDMIO_CHAMODE_ENDIAN2	0x00020000
#define DMAC_CDMIO_CHAMODE_ENDIAN3	0x00030000

#define DMAC_CDMIO_CH_ALLCLR		0x00000000
#define DMAC_CDMIO_CH_ER_MASK		0xffff0000
#define DMAC_CDMIO_CH_ER0		0x00010000
#define DMAC_CDMIO_CH_ER1		0x00020000
#define DMAC_CDMIO_CH_ER2		0x00040000
#define DMAC_CDMIO_CH_ER3		0x00080000
#define DMAC_CDMIO_CH_ER4		0x00100000
#define DMAC_CDMIO_CH_ER5		0x00200000
#define DMAC_CDMIO_CH_CH_MASK		0x0000ffff
#define DMAC_CDMIO_CH_CH0		0x00000001
#define DMAC_CDMIO_CH_CH1		0x00000002
#define DMAC_CDMIO_CH_CH4		0x00000010
#define DMAC_CDMIO_CH_CH5		0x00000020
#define DMAC_CDMIO_CH_CH13		0x00002000
#define DMAC_CDMIO_CH_CH14		0x00004000

#else /* CONFIG_MN2WS0220_ref || CONFIG_MN2WS0230_ref */

#define EMMC_CTL_BASEADDR	CONFIG_EMMC_CTL_BASEADDR
#define EMMC_IF_BASEADDR	CONFIG_EMMC_IF_BASEADDR
#define MMC_CTL_BASEADDR	CONFIG_MMC_CTL_BASEADDR
#define MMC_IF_BASEADDR		CONFIG_MMC_IF_BASEADDR

#define SD_CLKCTRL0		(MMC_CTL_BASEADDR + 0x00000020)
#define SD_CLKCTRL1		(EMMC_CTL_BASEADDR + 0x00000020)
#define SD_MODECTRL0		(MMC_CTL_BASEADDR + 0x00000030)
#define SD_MODECTRL1		(EMMC_CTL_BASEADDR + 0x00000030)
#define SD_BYTESWAP0		(MMC_CTL_BASEADDR + 0x000000CC)
#define SD_BYTESWAP1		(EMMC_CTL_BASEADDR + 0x000000CC)
#define SD_RSTCTRL0		(MMC_CTL_BASEADDR + 0x00000110)
#define SD_RSTCTRL1		(EMMC_CTL_BASEADDR + 0x00000110)
#define SD_EMMC1_HWRST		(EMMC_CTL_BASEADDR + 0x00000080)

#define DM_CM_DTRAN_MODE	0x00000410
#define DM_CM_DTRAN_CTRL	0x00000414
#define DM_CM_RST		0x00000418
#define DM_CM_INFO1		0x00000420
#define DM_CM_INFO1_MASK	0x00000424
#define DM_CM_INFO2		0x00000428
#define DM_CM_INFO2_MASK	0x0000042C
#define DM_DTRAN_ADDR		0x00000440
#define DM_DTRAN_ADDREX		0x00000444

#define DM_CM_DTRAN_MODE_ADDR_MODE			(1 << 0)
#define DM_CM_DTRAN_MODE_ADDR_MODE_FIXED		(0 << 0)
#define DM_CM_DTRAN_MODE_ADDR_MODE_INCREMENT		(1 << 0)
#define DM_CM_DTRAN_MODE_BUS_WIDTH			(3 << 4)
#define DM_CM_DTRAN_MODE_BUS_WIDTH_8			(0 << 4)
#define DM_CM_DTRAN_MODE_BUS_WIDTH_16			(1 << 4)
#define DM_CM_DTRAN_MODE_BUS_WIDTH_32			(2 << 4)
#define DM_CM_DTRAN_MODE_BUS_WIDTH_64			(3 << 4)
#define DM_CM_DTRAN_MODE_CH_NUM				(3 << 16)
#define DM_CM_DTRAN_MODE_CH_NUM_TO_MMC			(0 << 16)
#define DM_CM_DTRAN_MODE_CH_NUM_FROM_MMC		(1 << 16)
#define DM_CM_DTRAN_ADDR_DADDR				0xfffffff8
#define DM_CM_DTRAN_CTRL_DM_SEL				(1 << 8)
#define DM_CM_DTRAN_CTRL_DM_SEL_MMC			(0 << 8)
#define DM_CM_DTRAN_CTRL_DM_START			(1 << 0)
#define DM_CM_INFO1_DTARNEND				(0xf << 16)
#define DM_CM_INFO1_DTARNEND_TO_MMC			(0x1 << 16)
#define DM_CM_INFO1_DTARNEND_FROM_MMC			(0x2 << 16)
#define DM_CM_INFO1_MASK_DTARNEND_MASK			(0xf << 16)
#define DM_CM_INFO1_MASK_DTARNEND_MASK_TO_MMC		(0x1 << 16)
#define DM_CM_INFO1_MASK_DTARNEND_MASK_FROM_MMC		(0x2 << 16)
#define DM_CM_INFO2_DTARNERR				(0xf << 16)
#define DM_CM_INFO2_DTARNERR_TO_MMC			(0x1 << 16)
#define DM_CM_INFO2_DTARNERR_FROM_MMC			(0x2 << 16)
#define DM_CM_INFO2_MASK_DTARNERR			(0xf << 16)
#define DM_CM_INFO2_MASK_DTARNERR_TO_MMC		(0x1 << 16)
#define DM_CM_INFO2_MASK_DTARNERR_FROM_MMC		(0x2 << 16)

#define SD_CLKCTRL0_SDIO0ON				(1 << 8)
#define SD_CLKCTRL0_SDIO0ON_OFF				(0 << 8)
#define SD_CLKCTRL0_SDIO0ON_ON				(1 << 8)
#define SD_RSTCTRL0_SDIO0RST				(1 << 0)
#define SD_RSTCTRL0_SDIO0RST_RESET			(0 << 0)
#define SD_RSTCTRL0_SDIO0RST_CLEAR			(1 << 0)
#define SD_MODECTRL0_sdclksel0_sdclkmod0		((3 << 16) | (1 << 12) | (3 << 8))
#define SD_MODECTRL0_sdclksel0_sdclkmod0_22_2MHZ	(            (1 << 12) | (3 << 8))
#define SD_MODECTRL0_sdclksel0_sdclkmod0_25MHZ		(            (1 << 12) | (2 << 8))
#define SD_MODECTRL0_sdclksel0_sdclkmod0_33_3MHZ	((1 << 16) | (0 << 12)           )
#define SD_MODECTRL0_sdclksel0_sdclkmod0_40MHZ		(            (1 << 12) | (1 << 8))
#define SD_MODECTRL0_sdclksel0_sdclkmod0_44_4MHZ	((0 << 16) | (0 << 12)           )
#define SD_MODECTRL0_sdclksel0_sdclkmod0_50MHZ		((2 << 16) | (0 << 12)           )
#define SD_MODECTRL0_sdclksel0_sdclkmod0_66_7MHZ	((3 << 16) | (0 << 12)           )
#define SD_MODECTRL0_sdclksel0_sdclkmod0_100MHZ		(            (1 << 12) | (0 << 8))
#define SD_MODECTRL0_BswapenSD0				(1 << 21)
#define SD_MODECTRL0_BswapenSD0_NOSWAP			(0 << 21)
#define SD_MODECTRL0_BswapenSD0_SWAP			(1 << 21)
#define SD_MODECTRL0_mmcmode0				(1 << 27)
#define SD_MODECTRL0_mmcmode0_SD			(0 << 27)
#define SD_MODECTRL0_mmcmode0_EMMC			(1 << 27)

#define SD_CLKCTRL1_SDIO1ON				(1 << 8)
#define SD_CLKCTRL1_SDIO1ON_OFF				(0 << 8)
#define SD_CLKCTRL1_SDIO1ON_ON				(1 << 8)
#define SD_RSTCTRL1_SDIO1RST				(1 << 0)
#define SD_RSTCTRL1_SDIO1RST_RESET			(0 << 0)
#define SD_RSTCTRL1_SDIO1RST_CLEAR			(1 << 0)
#define SD_MODECTRL1_sdclksel1_sdclkmod1		((3 << 16) | (1 << 12) | (3 << 8))
#define SD_MODECTRL1_sdclksel1_sdclkmod1_22_5MHZ	(            (1 << 12) | (3 << 8))
#define SD_MODECTRL1_sdclksel1_sdclkmod1_25MHZ		(            (1 << 12) | (2 << 8))
#define SD_MODECTRL1_sdclksel1_sdclkmod1_33_3MHZ	((1 << 16) | (0 << 12)           )
#define SD_MODECTRL1_sdclksel1_sdclkmod1_40MHZ		(            (1 << 12) | (1 << 8))
#define SD_MODECTRL1_sdclksel1_sdclkmod1_45MHZ		((0 << 16) | (0 << 12)           )
#define SD_MODECTRL1_sdclksel1_sdclkmod1_50MHZ		((2 << 16) | (0 << 12)           )
#define SD_MODECTRL1_sdclksel1_sdclkmod1_66_7MHZ	((3 << 16) | (0 << 12)           )
#define SD_MODECTRL1_sdclksel1_sdclkmod1_100MHZ		(            (1 << 12) | (0 << 8))
#define SD_MODECTRL1_BswapenSD1				(1 << 21)
#define SD_MODECTRL1_BswapenSD1_NOSWAP			(0 << 21)
#define SD_MODECTRL1_BswapenSD1_SWAP			(1 << 21)
#define SD_MODECTRL1_mmcmode1				(1 << 27)
#define SD_MODECTRL1_mmcmode1_SD			(0 << 27)
#define SD_MODECTRL1_mmcmode1_EMMC			(1 << 27)
#endif /* CONFIG_MN2WS0220_ref || CONFIG_MN2WS0230_ref */

/* SDIP register */
#define REG_SD_CMD		0x0000
#define REG_SD_PORTSEL		0x0004
#define REG_SD_ARG0		0x0008
#define REG_SD_ARG1		0x000C
#define REG_SD_STOP		0x0010
#define REG_SD_SECCNT		0x0014
#define REG_SD_RSP0		0x0018
#define REG_SD_RSP1		0x001C
#define REG_SD_RSP2		0x0020
#define REG_SD_RSP3		0x0024
#define REG_SD_RSP4		0x0028
#define REG_SD_RSP5		0x002C
#define REG_SD_RSP6		0x0030
#define REG_SD_RSP7		0x0034
#define REG_SD_INFO1		0x0038
#define REG_SD_INFO2		0x003C
#define REG_SD_INFO1_MASK	0x0040
#define REG_SD_INFO2_MASK	0x0044
#define REG_SD_CLK_CTRL		0x0048
#define REG_SD_SIZE		0x004C
#define REG_SD_OPTION		0x0050
#define REG_SD_ERR_STS1		0x0058
#define REG_SD_ERR_STS2		0x005C
#define REG_SD_BUF		0x0060
#define REG_SDIO_MODE		0x0068
#define REG_SDIO_INFO1		0x006C
#define REG_SDIO_INFO1_MASK	0x0070
#define REG_CC_EXT_MODE		0x01B0
#define REG_SOFT_RST		0x01C0
#define REG_VERSION		0x01C4
#define REG_HOST_MODE		0x01C8
#define REG_SDIF_MODE		0x01CC
#define REG_STATUS		0x01E4
#define REG_EXT_SDIO		0x01E8
#define REG_EXT_WP		0x01EC
#define REG_EXT_CD		0x01F0
#define REG_EXT_CD_DAT3		0x01F4
#define REG_EXT_CD_MASK		0x01F8
#define REG_EXT_CD_DAT3_MASK	0x01FC

/* SD_CMD define */
#define SD_CMD_MODE_NORMAL	0x0000

#define SD_CMD_BK_SINGLE	0x0000
#define SD_CMD_BK_MULT		0x2000

#define SD_CMD_RW_WRITE		0x0000
#define SD_CMD_RW_READ		0x1000

#define SD_CMD_DAT_NODATA	0x0000
#define SD_CMD_DAT_ADTC		0x0800

#define SD_CMD_RESP_NORMAL	0x0000
#define SD_CMD_RESP_NORESP	0x0300
#define SD_CMD_RESP_R1		0x0400	/* R1,  R5,  R6,  R7 */
#define SD_CMD_RESP_R1B		0x0500	/* R1b, R5b */
#define SD_CMD_RESP_R2		0x0600	/* R2 */
#define SD_CMD_RESP_R3		0x0700	/* R3,  R4 */

#define SD_CMD_APP_NORMAL	0x0000
#define SD_CMD_APP_ACMD		0x0040

/* SD_INFO1 define */
#define SD_INFO1_INFO_RWA_CMP	0x0004
#define SD_INFO1_INFO_CMD_CMP	0x0001

#define SD_INFO1_INFO_CARD_ALL	0x0018
#define SD_INFO1_MASK_ALL	0x031d

/* SD_INFO2 define */
#define SD_INFO2_ERROR_ILA	0x8000
#define SD_INFO2_ERROR_RESP_TO	0x0040
#define SD_INFO2_ERROR_ILRA	0x0020
#define SD_INFO2_ERROR_ILWA	0x0010
#define SD_INFO2_ERROR_TO	0x0008
#define SD_INFO2_ERROR_ENDBIT	0x0004
#define SD_INFO2_ERROR_CRC	0x0002
#define SD_INFO2_ERROR_CMD	0x0001
#define SD_INFO2_ERROR_ALL	(SD_INFO2_ERROR_ILA     | \
				 SD_INFO2_ERROR_RESP_TO | \
				 SD_INFO2_ERROR_ILRA    | \
				 SD_INFO2_ERROR_ILWA    | \
				 SD_INFO2_ERROR_TO      | \
				 SD_INFO2_ERROR_ENDBIT  | \
				 SD_INFO2_ERROR_CRC     | \
				 SD_INFO2_ERROR_CMD)

#define SD_INFO2_INFO_CBSY	0x4000
#define SD_INFO2_INFO_BWE	0x0200
#define SD_INFO2_INFO_BRE	0x0100

#define SD_INFO2_MASK_ALL	0x8b7f

#define ENABLE_MMC	0
#define ENABLE_SDIO	1
#define ENABLE_EMMC	2

typedef struct uniphier_mmc {
	u32 reg_sdip_base;
	int dma_ch;
	int appcmd_flg;
	int id;			/* SD controller #ch */
	int enable_sdio;	/* 0:MMC 1:SDIO 2:eMMC */
} uniphier_mmc_t;

#endif /* __UNIPHIER_MMC__H__ */
