/*
 * Configuation settings for MN2WS0270_ref
 *
 * Copyright (C) 2010 Panasonic Corporation
 * All Rights Reserved.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#ifndef __MN2WS0270_ref_H
#define __MN2WS0270_ref_H

#include <knl_autoconf.h>

/*-----------------------------------------------------------------------
 * CPU Type		(no use this define)
 *----------------------------------------------------------------------*/
#define CONFIG_UNIPHIER
/*-----------------------------------------------------------------------
 * Board Type
 *----------------------------------------------------------------------*/
#define CONFIG_MN2WS0270_ref
/*-----------------------------------------------------------------------
 * Cache Setting
 *----------------------------------------------------------------------*/
//#define CONFIG_SYS_ICACHE_OFF
//#define CONFIG_SYS_DCACHE_OFF

/*-----------------------------------------------------------------------
 * Memory Size & Mapping
 *----------------------------------------------------------------------*/
#define CONFIG_NR_DRAM_BANKS		2
#define PHYS_SDRAM_1			0x80000000
#define PHYS_SDRAM_1_SIZE		0x10000000
#define PHYS_SDRAM_2			0xc0000000
#define PHYS_SDRAM_2_SIZE		0x10000000

#define CONFIG_SYS_SDRAM_BASE		0x8a000000
#define CONFIG_SYS_SDRAM_SIZE		0x01000000

#define CONFIG_SYS_TEXT_BASE		0x8a000000

#define CONFIG_SYS_INIT_RAM_ADDR	0x8a100000
#define CONFIG_SYS_INIT_RAM_SIZE	0x4000
#define CONFIG_SYS_INIT_SP_ADDR		(CONFIG_SYS_INIT_RAM_ADDR + \
					 CONFIG_SYS_INIT_RAM_SIZE - \
					 GENERATED_GBL_DATA_SIZE)

#define CONFIG_SYS_MALLOC_LEN		(1024 * 1024)

/* default load address */
#define CONFIG_SYS_LOAD_ADDR		0x8c000000

#define CONFIG_SYS_MEMTEST_START	(CONFIG_SYS_SDRAM_BASE + 0x00100000)
#define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_MEMTEST_START + 0x00100000)

/* start address of UNCACHE AREA */
#define CONFIG_SYS_DUMMY_UNCACHE_BASE	0xe0000000
#define CONFIG_SYS_MAINROM_BASE		0x8b000000
#define CONFIG_SYS_UNCACHE_BASE		0x8b800000
#define CONFIG_SYS_UNCACHE_SIZE		0x00100000

/* start of L2 cache registers */
#define CONFIG_SYS_L2C_BASE		0x50000000	/* P.A. */


/*-----------------------------------------------------------------------
 * first step setting
 *----------------------------------------------------------------------*/
#define LINUX_BOOT_PARAM_ADDR		(CONFIG_KERNEL_RAM_BASE_ADDRESS+0x3000)
#ifndef CONFIG_UNIPHIER_L2CACHE_ENABLE
#define CONFIG_SYS_L2CACHE_OFF		1
#endif
//#define CONFIG_SKIP_LOWLEVEL_INIT	1
//#define CONFIG_SYS_SKIP_ARM_RELOCATION	1
#define CONFIG_CMDLINE_TAG		1

/*-----------------------------------------------------------------------
 * Display CPU and Board information
 *----------------------------------------------------------------------*/
//#define CONFIG_DISPLAY_CPUINFO		1
//#define CONFIG_DISPLAY_BOARDINFO	1

/*-----------------------------------------------------------------------
 * UNIPHIER Serial Configuration
 *----------------------------------------------------------------------*/
#define CONFIG_UNIPHIER_SERIAL
#define CONFIG_UNIPHIER_SERIAL_HIGH_SPEED
#define CONFIG_UNIPHIER_SERIAL_BASE	0x54006a00

/*-----------------------------------------------------------------------
 * serial console configuration
 *----------------------------------------------------------------------*/
#define CONFIG_BAUDRATE			115200
#define CONFIG_NOREPEAT_COMMAND

/*-----------------------------------------------------------------------
 * Network configuration
 *----------------------------------------------------------------------*/
#define CONFIG_NET_MULTI
#define CONFIG_TFTP_BLOCKSIZE		1024
#define CONFIG_SYS_MAC_EEPROM		0	/* 1:MAC address recorded in EEPROM */

/*-----------------------------------------------------------------------
 * UNIPHIER Ethernet Configuration
 *----------------------------------------------------------------------*/
#define CONFIG_UNIPHIER_AVEV3
#define CONFIG_UNIPHIER_ETHERNET
#define CONFIG_UNIPHIER_ETHERNET_BASE	0x57000000
#define CONFIG_UNIPHIER_ETHERNET_NC_OFF	0x00000000

#define CONFIG_SMC911X
#define CONFIG_SMC911X_32_BIT
#define CONFIG_SMC911X_BASE		0x48000000

/*-----------------------------------------------------------------------
 * FLASH related
 *----------------------------------------------------------------------*/
#if 0
#define CONFIG_MTD_DEBUG
#define CONFIG_MTD_DEBUG_VERBOSE	7
#endif
#define CONFIG_MTD_DEVICE
#define CONFIG_SYS_NO_FLASH
//#define CONFIG_SYS_FLASH_BASE
//#define CONFIG_SYS_FLASH_SIZE

/*-----------------------------------------------------------------------
 * NAND-FLASH related
 *----------------------------------------------------------------------*/
#define CONFIG_SYS_MAX_NAND_DEVICE		1
#define CONFIG_NAND_GPBC
#define CONFIG_SYS_NAND_BASE			0x68000000
#define CONFIG_SYS_NAND_IOREMAP_SIZE		0x00000020
#define CONFIG_SYS_NAND_REG_BASE		0x68100000
#define CONFIG_SYS_NAND_REG_IOREMAP_BASE	0x00001000
#define CONFIG_MTD_NAND_MN2WS_GPBC_DMA
#ifdef CONFIG_NAND_GPBC
#define CONFIG_MTD_NAND_MN2WS_GPBC
#endif
#ifdef CONFIG_MTD_NAND_MN2WS_GPBC_DMA
#define CONFIG_MTD_NAND_MN2WS_GPBC_CDMA_READ
#endif
#ifdef  CONFIG_MTD_NAND_MN2WS_GPBC_CDMA_READ
#define CONFIG_NAND_UCAREA_ADDR			CONFIG_SYS_UNCACHE_BASE
#endif

/********** ORDER LIST *********/
#define NAND_MN2WS_AREA_ORDER_BDAM	0	/* BOOT, DATA, ALT,  BBM   */
#define NAND_MN2WS_AREA_ORDER_BDMA	1	/* BOOT, DATA, BBM,  ALT   */
#define NAND_MN2WS_AREA_ORDER_BADM	2	/* BOOT, ALT,  DATA, BBM   */
#define NAND_MN2WS_AREA_ORDER_BAMD	3	/* BOOT, ALT,  BBM,  DATA  */
#define NAND_MN2WS_AREA_ORDER_BMDA	4	/* BOOT, BBM,  DATA, ALT   */
#define NAND_MN2WS_AREA_ORDER_BMAD	5	/* BOOT, BBM,  ALT,  DATA  */
/******************************/
/* Area order: select from "ORDER LIST" */
#define CONFIG_SYS_NAND_AREA_ORDER	NAND_MN2WS_AREA_ORDER_BDAM

//#define CONFIG_SYS_NAND_SELECT_DEVICE
//#define CONFIG_JFFS2_NAND
#define CONFIG_MTD_NAND_MN2WS_USE_BBT_FLAG

/*
 * For NAND booting the environment is embedded in the U-Boot image. Please take
 * look at the file board/amcc/canyonlands/u-boot-nand.lds for details.
 */
#define CONFIG_SYS_NAND_BLOCK_SIZE	(CONFIG_MTD_NAND_MN2WS_CHIP_BLOCKSIZE)
#define CONFIG_SYS_NAND_PAGE_SIZE	(CONFIG_MTD_NAND_MN2WS_CHIP_PAGESIZE)
#define CONFIG_SYS_NAND_U_BOOT_OFFS	(CONFIG_SYS_NAND_BLOCK_SIZE * 4)
#define CONFIG_SYS_NAND_U_BOOT_SIZE	(CONFIG_SYS_NAND_BLOCK_SIZE * 3)

/* MMC related */
//#define CONFIG_GENERIC_MMC
//#define CONFIG_MN2WS0270_MMC
//#define CONFIG_MMC      /* init_part() */
//#define CONFIG_ISO_PARTITION    /* init_part() */
//#define CONFIG_MMC_TEST
//#define CONFIG_SYS_MMC_ENV_DEV	0

//#define CONFIG_ENV_IS_NOWHERE
#define CONFIG_ENV_IS_IN_NAND
//#define CONFIG_ENV_IS_IN_MMC

#ifdef CONFIG_ENV_IS_IN_NAND
#define CONFIG_ENV_SIZE			(CONFIG_SYS_NAND_BLOCK_SIZE * 1)
#define CONFIG_ENV_OFFSET		(CONFIG_SYS_NAND_U_BOOT_OFFS + CONFIG_SYS_NAND_U_BOOT_SIZE)
#endif

/*-----------------------------------------------------------------------
 * Possible commands
 *----------------------------------------------------------------------*/
//#define CONFIG_CMD_BDI		/* bdinfo			*/
#define CONFIG_CMD_BOOTD	/* bootd			*/
//#define CONFIG_CMD_CONSOLE	/* coninfo			*/
#define CONFIG_CMD_ECHO		/* echo arguments		*/
//#define CONFIG_CMD_EDITENV	/* editenv			*/
//#define CONFIG_CMD_IMI		/* iminfo			*/
//#define CONFIG_CMD_ITEST	/* Integer (and string) test	*/
#define CONFIG_CMD_NAND		/* NAND flash suppport */
//#define CONFIG_CMD_LOADB	/* loadb			*/
//#define CONFIG_CMD_LOADS	/* loads			*/
#define CONFIG_CMD_MEMORY	/* md mm nm mw cp cmp crc base loop mtest */
//#define CONFIG_CMD_MISC		/* Misc functions like sleep etc*/
#define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
//#define CONFIG_CMD_NFS		/* NFS support			*/
#define CONFIG_CMD_RUN		/* run command in env variable	*/
#define CONFIG_CMD_SAVEENV	/* saveenv			*/
//#define CONFIG_CMD_SOURCE	/* "source" command support	*/

//#define CONFIG_CMD_JFFS2	/* JFFS2 Support		*/
//#define CONFIG_CMD_PING
//#define CONFIG_CMD_MMC		/* MMC support			*/

/*-----------------------------------------------------------------------
 * Environment Variables
 *----------------------------------------------------------------------*/
#define CONFIG_BOOTDELAY		3
#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
#define CONFIG_AUTOBOOT_KEYED	1
#define CONFIG_AUTOBOOT_PROMPT	\
	"Press SPACE to abort autoboot in %d seconds\n", bootdelay
#define CONFIG_AUTOBOOT_DELAY_STR	"d"
#define CONFIG_AUTOBOOT_STOP_STR	" "

#define CONFIG_BOOTFILE		"uImage"

#define CONFIG_CMDLINE_EDITING		/* add command line history	*/

//#define CONFIG_BOOTCOMMAND	"bootm 0x00090000"
#define CONFIG_BOOTCOMMAND	"tftp uImage; bootm"

#define CONFIG_BOOTARGS	"root=/dev/mtdblock6 rootfstype=squashfs rw mem=149M@0x86A00000 mem=112M@0xC9000000 console=ttyS0,115200 user_debug=0x1f init=/bin/tainit"

#define	CONFIG_EXTRA_ENV_SETTINGS	\
"appxip=y\0"						\
"autoboot=y\0"


/*
 * Network Configuration
 */
//#define CONFIG_ETHADDR			00:21:83:24:00:00
#define CONFIG_LSERVERIP		156.147.69.82
#define CONFIG_SERVERIP			192.168.0.1
#define CONFIG_IPADDR			192.168.0.10
#define CONFIG_GATEWAYIP		192.168.0.1
#define CONFIG_NETMASK			255.255.255.0
/* #endif */
/*-----------------------------------------------------------------------
 * Miscellaneous Configuration Settings
 *----------------------------------------------------------------------*/
//#define CONFIG_SYS_LONGHELP		/* undef to save memory */
#define CONFIG_SYS_PROMPT		"UniPhier> "
#define CONFIG_CMDLINE_EDITING		/* add command line history	*/
#define CONFIG_SYS_HUSH_PARSER		/* use "hush" command parser */
#define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
#define CONFIG_SYS_CBSIZE		1024	/* Console I/O Buffer Size */
/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE		(CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS		16	/* max number of command */
#define CONFIG_SYS_64BIT_VSPRINTF
/* Boot Argument Buffer Size */
#define CONFIG_SYS_BARGSIZE		(CONFIG_SYS_CBSIZE)
/* List of legal baudrate settings for this board */
#define CONFIG_CONS_INDEX		1
#ifdef CONFIG_UNIPHIER_SERIAL_HIGH_SPEED
#define CONFIG_SYS_BAUDRATE_TABLE	{ 115200, 230400, 460800 }
#else
#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
#endif	/* CONFIG_UNIPHIER_SERIAL_HIGH_SPEED */
/* Increase max gunzip size */
#define CONFIG_SYS_BOOTM_LEN	(32 << 20)
/* Boot params (bootargs) length */
#define CONFIG_SYS_BOOTPARAMS_LEN	1024

/* System Clock */
#define CONFIG_SYS_HZ			1000

/* compression format (Remove definition, If you don't need) */
#define CONFIG_LZO
//#define CONFIG_LZMA
/* compression format (select CONFIG_GZIP/CONFIG_LZO / CONFIG_LZMA) */
// for CommonPF #define CONFIG_KERNEL_COMPRESS CONFIG_LZO
#define CONFIG_KERNEL_COMPRESS CONFIG_GZIP

#endif /* __MN2WS0270_ref_H */
